import{S as Xt,i as Zt,s as ea,e as o,k as p,w as A,t as n,M as ta,c as i,d as t,m as d,a as l,x as k,h as c,b as h,G as a,g as s,y as E,q as j,o as z,B as P,v as aa}from"../../chunks/vendor-hf-doc-builder.js";import{T as Vt}from"../../chunks/Tip-hf-doc-builder.js";import{I as Qe}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as me}from"../../chunks/CodeBlock-hf-doc-builder.js";function ra(re){let u,b,f,g,$;return{c(){u=o("p"),b=n("In its current state, this code is not going to perform gradient accumulation efficiently due to a process called gradient synchronization. Read more about that in the "),f=o("a"),g=n("Concepts tutorial"),$=n("!"),this.h()},l(m){u=i(m,"P",{});var w=l(u);b=c(w,"In its current state, this code is not going to perform gradient accumulation efficiently due to a process called gradient synchronization. Read more about that in the "),f=i(w,"A",{href:!0});var y=l(f);g=c(y,"Concepts tutorial"),y.forEach(t),$=c(w,"!"),w.forEach(t),this.h()},h(){h(f,"href","../concept_guides/gradient_synchronization")},m(m,w){s(m,u,w),a(u,b),a(u,f),a(f,g),a(u,$)},d(m){m&&t(u)}}}function oa(re){let u,b,f,g,$,m,w,y,S,L,x;return{c(){u=o("p"),b=n(`Typically with gradient accumulation, you would need to adjust the number of steps to reflect the change in total batches you are
training on. \u{1F917} Accelerate will automatically do this for you, so long as you pass `),f=o("code"),g=n("adjust_scheduler_to_accumulation"),$=n(" to the "),m=o("a"),w=n("Accelerator"),y=n(" object\u2019s "),S=o("code"),L=n("__init__"),x=n("."),this.h()},l(C){u=i(C,"P",{});var _=l(u);b=c(_,`Typically with gradient accumulation, you would need to adjust the number of steps to reflect the change in total batches you are
training on. \u{1F917} Accelerate will automatically do this for you, so long as you pass `),f=i(_,"CODE",{});var q=l(f);g=c(q,"adjust_scheduler_to_accumulation"),q.forEach(t),$=c(_," to the "),m=i(_,"A",{href:!0});var oe=l(m);w=c(oe,"Accelerator"),oe.forEach(t),y=c(_," object\u2019s "),S=i(_,"CODE",{});var R=l(S);L=c(R,"__init__"),R.forEach(t),x=c(_,"."),_.forEach(t),this.h()},h(){h(m,"href","/docs/accelerate/v0.18.0/en/package_reference/accelerator#accelerate.Accelerator")},m(C,_){s(C,u,_),a(u,b),a(u,f),a(f,g),a(u,$),a(u,m),a(m,w),a(u,y),a(u,S),a(S,L),a(u,x)},d(C){C&&t(u)}}}function ia(re){let u,b,f,g,$,m,w,y,S,L,x,C,_,q,oe,R,ie,Ve,Ee,se,Xe,je,W,ze,N,O,ge,J,Ze,_e,et,Pe,le,tt,xe,U,Te,B,Se,G,D,we,K,at,ve,rt,Ce,v,ot,$e,it,st,ne,lt,nt,be,ct,ut,ce,pt,dt,qe,Q,Ne,F,ht,ue,ft,mt,Ge,V,Ie,pe,gt,Le,X,Oe,H,_t,de,wt,vt,Be,Y,De,I,M,ye,Z,$t,Ae,bt,Fe,he,yt,He,ee,Ye,te,At,fe,kt,Me;return m=new Qe({}),W=new me({props:{code:`device = "cuda"
model.to(device)

gradient_accumulation_steps = 2

for index, batch in enumerate(training_dataloader):
    inputs, targets = batch
    inputs = inputs.to(device)
    targets = targets.to(device)
    outputs = model(inputs)
    loss = loss_function(outputs, targets)
    loss = loss / gradient_accumulation_steps
    loss.backward()
    if (index + 1) % gradient_accumulation_steps == 0:
        optimizer.step()
        scheduler.step()
        optimizer.zero_grad()`,highlighted:`device = <span class="hljs-string">&quot;cuda&quot;</span>
model.to(device)

gradient_accumulation_steps = <span class="hljs-number">2</span>

<span class="hljs-keyword">for</span> index, batch <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(training_dataloader):
    inputs, targets = batch
    inputs = inputs.to(device)
    targets = targets.to(device)
    outputs = model(inputs)
    loss = loss_function(outputs, targets)
    loss = loss / gradient_accumulation_steps
    loss.backward()
    <span class="hljs-keyword">if</span> (index + <span class="hljs-number">1</span>) % gradient_accumulation_steps == <span class="hljs-number">0</span>:
        optimizer.step()
        scheduler.step()
        optimizer.zero_grad()`}}),J=new Qe({}),U=new me({props:{code:`+ from accelerate import Accelerator
+ accelerator = Accelerator()

+ model, optimizer, training_dataloader, scheduler = accelerator.prepare(
+     model, optimizer, training_dataloader, scheduler
+ )

  for index, batch in enumerate(training_dataloader):
      inputs, targets = batch
-     inputs = inputs.to(device)
-     targets = targets.to(device)
      outputs = model(inputs)
      loss = loss_function(outputs, targets)
      loss = loss / gradient_accumulation_steps
+     accelerator.backward(loss)
      if (index+1) % gradient_accumulation_steps == 0:
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`,highlighted:`<span class="hljs-addition">+ from accelerate import Accelerator</span>
<span class="hljs-addition">+ accelerator = Accelerator()</span>

<span class="hljs-addition">+ model, optimizer, training_dataloader, scheduler = accelerator.prepare(</span>
<span class="hljs-addition">+     model, optimizer, training_dataloader, scheduler</span>
<span class="hljs-addition">+ )</span>

  for index, batch in enumerate(training_dataloader):
      inputs, targets = batch
<span class="hljs-deletion">-     inputs = inputs.to(device)</span>
<span class="hljs-deletion">-     targets = targets.to(device)</span>
      outputs = model(inputs)
      loss = loss_function(outputs, targets)
      loss = loss / gradient_accumulation_steps
<span class="hljs-addition">+     accelerator.backward(loss)</span>
      if (index+1) % gradient_accumulation_steps == 0:
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`}}),B=new Vt({props:{warning:!0,$$slots:{default:[ra]},$$scope:{ctx:re}}}),K=new Qe({}),Q=new me({props:{code:`  from accelerate import Accelerator
- accelerator = Accelerator()
+ accelerator = Accelerator(gradient_accumulation_steps=2)`,highlighted:`  from accelerate import Accelerator
<span class="hljs-deletion">- accelerator = Accelerator()</span>
<span class="hljs-addition">+ accelerator = Accelerator(gradient_accumulation_steps=2)</span>`}}),V=new me({props:{code:`- for index, batch in enumerate(training_dataloader):
+ for batch in training_dataloader:
+     with accelerator.accumulate(model):
          inputs, targets = batch
          outputs = model(inputs)`,highlighted:`<span class="hljs-deletion">- for index, batch in enumerate(training_dataloader):</span>
<span class="hljs-addition">+ for batch in training_dataloader:</span>
<span class="hljs-addition">+     with accelerator.accumulate(model):</span>
          inputs, targets = batch
          outputs = model(inputs)`}}),X=new me({props:{code:`- loss = loss / gradient_accumulation_steps
  accelerator.backward(loss)
- if (index+1) % gradient_accumulation_steps == 0:
  optimizer.step()
  scheduler.step()
  optimizer.zero_grad()`,highlighted:`<span class="hljs-deletion">- loss = loss / gradient_accumulation_steps</span>
  accelerator.backward(loss)
<span class="hljs-deletion">- if (index+1) % gradient_accumulation_steps == 0:</span>
  optimizer.step()
  scheduler.step()
  optimizer.zero_grad()`}}),Y=new Vt({props:{$$slots:{default:[oa]},$$scope:{ctx:re}}}),Z=new Qe({}),ee=new me({props:{code:`for batch in training_dataloader:
    with accelerator.accumulate(model):
        inputs, targets = batch
        outputs = model(inputs)
        loss = loss_function(outputs, targets)
        accelerator.backward(loss)
        optimizer.step()
        scheduler.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-keyword">for</span> batch <span class="hljs-keyword">in</span> training_dataloader:
    <span class="hljs-keyword">with</span> accelerator.accumulate(model):
        inputs, targets = batch
        outputs = model(inputs)
        loss = loss_function(outputs, targets)
        accelerator.backward(loss)
        optimizer.step()
        scheduler.step()
        optimizer.zero_grad()`}}),{c(){u=o("meta"),b=p(),f=o("h1"),g=o("a"),$=o("span"),A(m.$$.fragment),w=p(),y=o("span"),S=n("Performing gradient accumulation with \u{1F917} Accelerate"),L=p(),x=o("p"),C=n(`Gradient accumulation is a technique where you can train on bigger batch sizes than
your machine would normally be able to fit into memory. This is done by accumulating gradients over
several batches, and only stepping the optimizer after a certain number of batches have been performed.`),_=p(),q=o("p"),oe=n(`While technically standard gradient accumulation code would work fine in a distributed setup, it is not the most efficient
method for doing so and you may experience considerable slowdowns!`),R=p(),ie=o("p"),Ve=n(`In this tutorial you will see how to quickly setup gradient accumulation and perform it with the utilities provided in \u{1F917} Accelerate,
which can total to adding just one new line of code!`),Ee=p(),se=o("p"),Xe=n("This example will use a very simplistic PyTorch training loop that performs gradient accumulation every two batches:"),je=p(),A(W.$$.fragment),ze=p(),N=o("h2"),O=o("a"),ge=o("span"),A(J.$$.fragment),Ze=p(),_e=o("span"),et=n("Converting it to \u{1F917} Accelerate"),Pe=p(),le=o("p"),tt=n("First the code shown earlier will be converted to utilize \u{1F917} Accelerate without the special gradient accumulation helper:"),xe=p(),A(U.$$.fragment),Te=p(),A(B.$$.fragment),Se=p(),G=o("h2"),D=o("a"),we=o("span"),A(K.$$.fragment),at=p(),ve=o("span"),rt=n("Letting \u{1F917} Accelerate handle gradient accumulation"),Ce=p(),v=o("p"),ot=n("All that is left now is to let \u{1F917} Accelerate handle the gradient accumulation for us. To do so you should pass in a "),$e=o("code"),it=n("gradient_accumulation_steps"),st=n(" parameter to "),ne=o("a"),lt=n("Accelerator"),nt=n(`, dictating the number
of steps to perform before each call to `),be=o("code"),ct=n("step()"),ut=n(" and how to automatically adjust the loss during the call to "),ce=o("a"),pt=n("backward()"),dt=n(":"),qe=p(),A(Q.$$.fragment),Ne=p(),F=o("p"),ht=n("From here you can use the "),ue=o("a"),ft=n("accumulate()"),mt=n(` context manager from inside your training loop to automatically perform the gradient accumulation for you!
You just wrap it around the entire training part of our code:`),Ge=p(),A(V.$$.fragment),Ie=p(),pe=o("p"),gt=n("You can remove all the special checks for the step number and the loss adjustment:"),Le=p(),A(X.$$.fragment),Oe=p(),H=o("p"),_t=n("As you can see the "),de=o("a"),wt=n("Accelerator"),vt=n(" is able to keep track of the batch number you are on and it will automatically know whether to step through the prepared optimizer and how to adjust the loss."),Be=p(),A(Y.$$.fragment),De=p(),I=o("h2"),M=o("a"),ye=o("span"),A(Z.$$.fragment),$t=p(),Ae=o("span"),bt=n("The finished code"),Fe=p(),he=o("p"),yt=n("Below is the finished implementation for performing gradient accumulation with \u{1F917} Accelerate"),He=p(),A(ee.$$.fragment),Ye=p(),te=o("p"),At=n("To learn more about what magic this wraps around, read the "),fe=o("a"),kt=n("Gradient Synchronization concept guide"),this.h()},l(e){const r=ta('[data-svelte="svelte-1phssyn"]',document.head);u=i(r,"META",{name:!0,content:!0}),r.forEach(t),b=d(e),f=i(e,"H1",{class:!0});var ae=l(f);g=i(ae,"A",{id:!0,class:!0,href:!0});var ke=l(g);$=i(ke,"SPAN",{});var jt=l($);k(m.$$.fragment,jt),jt.forEach(t),ke.forEach(t),w=d(ae),y=i(ae,"SPAN",{});var zt=l(y);S=c(zt,"Performing gradient accumulation with \u{1F917} Accelerate"),zt.forEach(t),ae.forEach(t),L=d(e),x=i(e,"P",{});var Pt=l(x);C=c(Pt,`Gradient accumulation is a technique where you can train on bigger batch sizes than
your machine would normally be able to fit into memory. This is done by accumulating gradients over
several batches, and only stepping the optimizer after a certain number of batches have been performed.`),Pt.forEach(t),_=d(e),q=i(e,"P",{});var xt=l(q);oe=c(xt,`While technically standard gradient accumulation code would work fine in a distributed setup, it is not the most efficient
method for doing so and you may experience considerable slowdowns!`),xt.forEach(t),R=d(e),ie=i(e,"P",{});var Tt=l(ie);Ve=c(Tt,`In this tutorial you will see how to quickly setup gradient accumulation and perform it with the utilities provided in \u{1F917} Accelerate,
which can total to adding just one new line of code!`),Tt.forEach(t),Ee=d(e),se=i(e,"P",{});var St=l(se);Xe=c(St,"This example will use a very simplistic PyTorch training loop that performs gradient accumulation every two batches:"),St.forEach(t),je=d(e),k(W.$$.fragment,e),ze=d(e),N=i(e,"H2",{class:!0});var Re=l(N);O=i(Re,"A",{id:!0,class:!0,href:!0});var Ct=l(O);ge=i(Ct,"SPAN",{});var qt=l(ge);k(J.$$.fragment,qt),qt.forEach(t),Ct.forEach(t),Ze=d(Re),_e=i(Re,"SPAN",{});var Nt=l(_e);et=c(Nt,"Converting it to \u{1F917} Accelerate"),Nt.forEach(t),Re.forEach(t),Pe=d(e),le=i(e,"P",{});var Gt=l(le);tt=c(Gt,"First the code shown earlier will be converted to utilize \u{1F917} Accelerate without the special gradient accumulation helper:"),Gt.forEach(t),xe=d(e),k(U.$$.fragment,e),Te=d(e),k(B.$$.fragment,e),Se=d(e),G=i(e,"H2",{class:!0});var We=l(G);D=i(We,"A",{id:!0,class:!0,href:!0});var It=l(D);we=i(It,"SPAN",{});var Lt=l(we);k(K.$$.fragment,Lt),Lt.forEach(t),It.forEach(t),at=d(We),ve=i(We,"SPAN",{});var Ot=l(ve);rt=c(Ot,"Letting \u{1F917} Accelerate handle gradient accumulation"),Ot.forEach(t),We.forEach(t),Ce=d(e),v=i(e,"P",{});var T=l(v);ot=c(T,"All that is left now is to let \u{1F917} Accelerate handle the gradient accumulation for us. To do so you should pass in a "),$e=i(T,"CODE",{});var Bt=l($e);it=c(Bt,"gradient_accumulation_steps"),Bt.forEach(t),st=c(T," parameter to "),ne=i(T,"A",{href:!0});var Dt=l(ne);lt=c(Dt,"Accelerator"),Dt.forEach(t),nt=c(T,`, dictating the number
of steps to perform before each call to `),be=i(T,"CODE",{});var Ft=l(be);ct=c(Ft,"step()"),Ft.forEach(t),ut=c(T," and how to automatically adjust the loss during the call to "),ce=i(T,"A",{href:!0});var Ht=l(ce);pt=c(Ht,"backward()"),Ht.forEach(t),dt=c(T,":"),T.forEach(t),qe=d(e),k(Q.$$.fragment,e),Ne=d(e),F=i(e,"P",{});var Je=l(F);ht=c(Je,"From here you can use the "),ue=i(Je,"A",{href:!0});var Yt=l(ue);ft=c(Yt,"accumulate()"),Yt.forEach(t),mt=c(Je,` context manager from inside your training loop to automatically perform the gradient accumulation for you!
You just wrap it around the entire training part of our code:`),Je.forEach(t),Ge=d(e),k(V.$$.fragment,e),Ie=d(e),pe=i(e,"P",{});var Mt=l(pe);gt=c(Mt,"You can remove all the special checks for the step number and the loss adjustment:"),Mt.forEach(t),Le=d(e),k(X.$$.fragment,e),Oe=d(e),H=i(e,"P",{});var Ue=l(H);_t=c(Ue,"As you can see the "),de=i(Ue,"A",{href:!0});var Rt=l(de);wt=c(Rt,"Accelerator"),Rt.forEach(t),vt=c(Ue," is able to keep track of the batch number you are on and it will automatically know whether to step through the prepared optimizer and how to adjust the loss."),Ue.forEach(t),Be=d(e),k(Y.$$.fragment,e),De=d(e),I=i(e,"H2",{class:!0});var Ke=l(I);M=i(Ke,"A",{id:!0,class:!0,href:!0});var Wt=l(M);ye=i(Wt,"SPAN",{});var Jt=l(ye);k(Z.$$.fragment,Jt),Jt.forEach(t),Wt.forEach(t),$t=d(Ke),Ae=i(Ke,"SPAN",{});var Ut=l(Ae);bt=c(Ut,"The finished code"),Ut.forEach(t),Ke.forEach(t),Fe=d(e),he=i(e,"P",{});var Kt=l(he);yt=c(Kt,"Below is the finished implementation for performing gradient accumulation with \u{1F917} Accelerate"),Kt.forEach(t),He=d(e),k(ee.$$.fragment,e),Ye=d(e),te=i(e,"P",{});var Et=l(te);At=c(Et,"To learn more about what magic this wraps around, read the "),fe=i(Et,"A",{href:!0});var Qt=l(fe);kt=c(Qt,"Gradient Synchronization concept guide"),Qt.forEach(t),Et.forEach(t),this.h()},h(){h(u,"name","hf:doc:metadata"),h(u,"content",JSON.stringify(sa)),h(g,"id","performing-gradient-accumulation-with-accelerate"),h(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(g,"href","#performing-gradient-accumulation-with-accelerate"),h(f,"class","relative group"),h(O,"id","converting-it-to-accelerate"),h(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(O,"href","#converting-it-to-accelerate"),h(N,"class","relative group"),h(D,"id","letting-accelerate-handle-gradient-accumulation"),h(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(D,"href","#letting-accelerate-handle-gradient-accumulation"),h(G,"class","relative group"),h(ne,"href","/docs/accelerate/v0.18.0/en/package_reference/accelerator#accelerate.Accelerator"),h(ce,"href","/docs/accelerate/v0.18.0/en/package_reference/accelerator#accelerate.Accelerator.backward"),h(ue,"href","/docs/accelerate/v0.18.0/en/package_reference/accelerator#accelerate.Accelerator.accumulate"),h(de,"href","/docs/accelerate/v0.18.0/en/package_reference/accelerator#accelerate.Accelerator"),h(M,"id","the-finished-code"),h(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(M,"href","#the-finished-code"),h(I,"class","relative group"),h(fe,"href","../concept_guides/gradient_synchronization")},m(e,r){a(document.head,u),s(e,b,r),s(e,f,r),a(f,g),a(g,$),E(m,$,null),a(f,w),a(f,y),a(y,S),s(e,L,r),s(e,x,r),a(x,C),s(e,_,r),s(e,q,r),a(q,oe),s(e,R,r),s(e,ie,r),a(ie,Ve),s(e,Ee,r),s(e,se,r),a(se,Xe),s(e,je,r),E(W,e,r),s(e,ze,r),s(e,N,r),a(N,O),a(O,ge),E(J,ge,null),a(N,Ze),a(N,_e),a(_e,et),s(e,Pe,r),s(e,le,r),a(le,tt),s(e,xe,r),E(U,e,r),s(e,Te,r),E(B,e,r),s(e,Se,r),s(e,G,r),a(G,D),a(D,we),E(K,we,null),a(G,at),a(G,ve),a(ve,rt),s(e,Ce,r),s(e,v,r),a(v,ot),a(v,$e),a($e,it),a(v,st),a(v,ne),a(ne,lt),a(v,nt),a(v,be),a(be,ct),a(v,ut),a(v,ce),a(ce,pt),a(v,dt),s(e,qe,r),E(Q,e,r),s(e,Ne,r),s(e,F,r),a(F,ht),a(F,ue),a(ue,ft),a(F,mt),s(e,Ge,r),E(V,e,r),s(e,Ie,r),s(e,pe,r),a(pe,gt),s(e,Le,r),E(X,e,r),s(e,Oe,r),s(e,H,r),a(H,_t),a(H,de),a(de,wt),a(H,vt),s(e,Be,r),E(Y,e,r),s(e,De,r),s(e,I,r),a(I,M),a(M,ye),E(Z,ye,null),a(I,$t),a(I,Ae),a(Ae,bt),s(e,Fe,r),s(e,he,r),a(he,yt),s(e,He,r),E(ee,e,r),s(e,Ye,r),s(e,te,r),a(te,At),a(te,fe),a(fe,kt),Me=!0},p(e,[r]){const ae={};r&2&&(ae.$$scope={dirty:r,ctx:e}),B.$set(ae);const ke={};r&2&&(ke.$$scope={dirty:r,ctx:e}),Y.$set(ke)},i(e){Me||(j(m.$$.fragment,e),j(W.$$.fragment,e),j(J.$$.fragment,e),j(U.$$.fragment,e),j(B.$$.fragment,e),j(K.$$.fragment,e),j(Q.$$.fragment,e),j(V.$$.fragment,e),j(X.$$.fragment,e),j(Y.$$.fragment,e),j(Z.$$.fragment,e),j(ee.$$.fragment,e),Me=!0)},o(e){z(m.$$.fragment,e),z(W.$$.fragment,e),z(J.$$.fragment,e),z(U.$$.fragment,e),z(B.$$.fragment,e),z(K.$$.fragment,e),z(Q.$$.fragment,e),z(V.$$.fragment,e),z(X.$$.fragment,e),z(Y.$$.fragment,e),z(Z.$$.fragment,e),z(ee.$$.fragment,e),Me=!1},d(e){t(u),e&&t(b),e&&t(f),P(m),e&&t(L),e&&t(x),e&&t(_),e&&t(q),e&&t(R),e&&t(ie),e&&t(Ee),e&&t(se),e&&t(je),P(W,e),e&&t(ze),e&&t(N),P(J),e&&t(Pe),e&&t(le),e&&t(xe),P(U,e),e&&t(Te),P(B,e),e&&t(Se),e&&t(G),P(K),e&&t(Ce),e&&t(v),e&&t(qe),P(Q,e),e&&t(Ne),e&&t(F),e&&t(Ge),P(V,e),e&&t(Ie),e&&t(pe),e&&t(Le),P(X,e),e&&t(Oe),e&&t(H),e&&t(Be),P(Y,e),e&&t(De),e&&t(I),P(Z),e&&t(Fe),e&&t(he),e&&t(He),P(ee,e),e&&t(Ye),e&&t(te)}}}const sa={local:"performing-gradient-accumulation-with-accelerate",sections:[{local:"converting-it-to-accelerate",title:"Converting it to \u{1F917} Accelerate"},{local:"letting-accelerate-handle-gradient-accumulation",title:"Letting \u{1F917} Accelerate handle gradient accumulation"},{local:"the-finished-code",title:"The finished code"}],title:"Performing gradient accumulation with \u{1F917} Accelerate"};function la(re){return aa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class da extends Xt{constructor(u){super();Zt(this,u,la,ia,ea,{})}}export{da as default,sa as metadata};
